
--[[~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~]]--
--[[~]] MedicGunParticles=20
--[[~]] FlowWallTest=101 -- it checks wall between healer and patient (less causes bad work of a medigun)
--[[~]] MedicGunHeal=2 -- per 0.1 of second
--[[~]] MedicGunMaxOverHeal=50 -- HP
--[[~]] RGBRed="220 70 40" -- color of flow for RED TEAM
--[[~]] RGBBlue="40 70 220" -- color of flow for RED TEAM
--[[~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~]]--

--~Basic function for fill table with w~--
function initMe(n,w)
local anyF={}
	for i=1,n do 
		anyF[i]=w
	end
	return anyF
end

--~Draws line between xH and xV with step t~--
function clickX2(xH,xV,id)
return (1-t[id])*xH+t[id]*xV
end

--~Draws line between 3 points with step t~--~ http://en.wikipedia.org/wiki/B%C3%A9zier_curve ~--
function clickX3(xH,x2,xV,id)
return (1-t[id])^2*xH+2*(1-t[id])*t[id]*x2+t[id]^2*(xV*32+16)
end

k=0
t=initMe(32,0)
b=initMe(32,0)
n=initMe(32,0)
xB=initMe(32,0)
yB=initMe(32,0)
team=initMe(32,0)
spriteCover=initMe(32,0)
move=initMe(32,false)
down=initMe(32,false)
selectMedic=initMe(32,false)
MedicGunParticlesStep=1/MedicGunParticles
MedicGunMaxOverHeal=MedicGunMaxOverHeal+100

--[[~~~~~~~~~~~~~~~~~~~MEDICGUN~~~~~~~~~~~~~~~~~~~~~]]--

addhook("ms100","sendPos")
function sendPos()
	for id=1,#player(0,"table") do
		if (player(id,"exists")) then
			reqcld(id,2)
			move[id]=false
		end
	end
end

addhook("clientdata","readClData")
function readClData(id,mode,x3,y3)
	if selectMedic[id] then
		if player(id,"health")>0 then
			xB[id]=x3
			yB[id]=y3
			selectMedic[id]=false
		end
	end
	if player(id,"weapon")==85 then
		if not move[id] then
			freeimage(spriteCover[id])
			spriteCover[id]=image("gfx/-[TeamFortress2]-/Weapons/medigun"..team[id]..".bmp<m>",1,1,200+id)
			n[id]=0
		end
	end
end

addhook("attack","medicGun")
function medicGun(id)
	if player(id,"weapon")==85 then
		selectMedic[id]=true
		r1=math.floor(xB[id]/32)
		r2=math.floor(yB[id]/32)
		for i=r1-1,r1+1 do
			for j=r2-1,r2+1 do
				for k=1,32 do
					if k~=id then
						xV=player(k,"tilex")
						yV=player(k,"tiley")
						if xV==i and yV==j then 
							if player(id,"team")==player(k,"team") then
								heal(id,k,xV,yV)
							end
						end
					end
				end
			end
		end
	end
end

function heal(id,k,xV,yV)
	if player(id,"team")==1 then RGB=RGBRed else RGB=RGBBlue end
	for i=1,FlowWallTest do
		local xT=clickX2(player(id,"tilex"),xV,id)
		local yT=clickX2(player(id,"tiley"),yV,id)
		t[id]=t[id]+1/FlowWallTest
		if tile(xT,yT,"wall") then 
			return
		end
	end
	t[id]=0
	for i=1,MedicGunParticles do
		parse('effect "flare" '..clickX3(player(id,"x"),xB[id]+math.cos(math.rad(player(id,"rot")))*5,xV,id)..' '..clickX3(player(id,"y"),yB[id]+math.sin(math.rad(player(id,"rot")))*5,yV,id)..' 1 1 '..RGB)
		t[id]=t[id]+MedicGunParticlesStep
	end
	t[id]=0
	parse("setmaxhealth "..k.." "..player(k,"health")+MedicGunHeal)
	if player(k,"health")>MedicGunMaxOverHeal then
		parse("setmaxhealth "..k.." "..MedicGunMaxOverHeal)
	end
end

addhook("hit","noSAW")
function noSAW(id,srs,wep)
	if wep==85 then 
		return 1
	end
end

addhook("select","MedigunSprite")
function MedigunSprite(id,wep)
	local c=player(id,"speedmod")
	if wep==85 then
		if player(id,"team")==1 then team[id]="Red" else team[id]="Blue" end
		freeimage(spriteCover[id])
		spriteCover[id]=image("gfx/-[TeamFortress2]-/Weapons/medigun"..team[id]..".bmp<m>",1,1,200+id)
		parse("speedmod "..id.." -100")
		timer(125+player(id,"ping"),"parse","lua retSpeed("..id..","..c..")")
		c=nil
		n[id]=0 
	else
		freeimage(spriteCover[id])
	end
end

addhook("move","rotate")
function rotate(id,x,y,walkk)
	if player(id,"weapon")==85 then
		local was=down[id]
		local c=player(id,"speedmod")
		move[id]=true
		if walkk==0 then
			down[id]=true
			b[id]=player(id,"rot")+math.sin(math.rad(n[id])*20)*5
		else 
			down[id]=false
			b[id]=player(id,"rot")+math.sin(math.rad(n[id])*10)*5
		end
		if down[id]~=was then
			parse("speedmod "..id.." -100")
			timer(125+player(id,"ping"),"parse","lua retSpeed("..id..","..c..")")
			c=nil
			n[id]=0
		end
			freeimage(spriteCover[id])
			spriteCover[id]=image("gfx/-[TeamFortress2]-/Weapons/medigun"..team[id]..".bmp<m>",-1,-1,1)
			imagepos(spriteCover[id],x,y,b[id])
			n[id]=n[id]+0.5
	else
		n[id]=0
	end
end

function retSpeed(id,c)
	parse("speedmod "..id.." "..c)
end

addhook("die","freeimg")
function freeimg(id)
	if player(id,"weapon")==85 then
		freeimage(spriteCover[id])
	end
end